from cpl_core.configuration import ConfigurationModelABC
from cpl_core.utils.json_processor import JSONProcessor
from cpl_query.extension import List

from modules.base.configuration.base_server_settings import BaseServerSettings


class BaseSettings(ConfigurationModelABC):
    def __init__(self, **kwargs: dict):
        ConfigurationModelABC.__init__(self)

        self._servers: List[BaseServerSettings] = List()
        for s in kwargs:
            kwargs[s]["Id"] = s
            self._servers.append(JSONProcessor.process(BaseServerSettings, kwargs[s]))

    @property
    def servers(self) -> List[BaseServerSettings]:
        return self._servers
